using System;
using System.Net.Sockets;

namespace UPSLT
{
	namespace Services
	{	
		namespace Chat
		{
			public class ChatClient
			{
				// private member variables
				private Socket m_pipe;																	// Client's socket connection to the server
				private byte[] m_byteBuffer;														// Buffer to hold byte data
				private string m_strBuffer;															// Buffer to hold string ver of byte data
				private bool m_bLoggedIn;																// Whether or not the user is logged in
				private string m_strNickname;														// Client user's nickname			
				
				// public member properties
				public Socket Pipe
				{ get { return m_pipe; } }
				
				public byte[] ByteBuffer
				{	get { return m_byteBuffer; } }
				
				public string StringBuffer
				{ get { return m_strBuffer; } }
				
				public bool LoggedIn
				{ 
					get { return m_bLoggedIn; } 
					set { m_bLoggedIn = value; }
				}
				
				public string Nickname
				{	
					get { return m_strNickname; } 
					set { m_strNickname = value; }
				}
				
				
				// constructor
				public ChatClient(Socket _pipe)
				{
					m_pipe = _pipe;
					m_bLoggedIn = false;
					m_strNickname = string.Empty;
					ResetStringBuffer();
				}
				
				//-------------------------
				// Public Member Functions
				//-------------------------
				public byte[] ResetByteBuffer(int _nBufferSize)
				{
					m_byteBuffer = new byte[_nBufferSize];
					return m_byteBuffer;
				}
				
				public void AppendStringBuffer(string _str)
				{
					m_strBuffer += _str;
				}
				
				public void ResetStringBuffer()
				{
					m_strBuffer = string.Empty;
				}
			}
		}
	}
}
