using System.Web.UI;
using System.Web.UI.WebControls;

namespace sstchur
{
  namespace web
  {
		namespace survey
		{
			public class McmsWebQuestion : WebQuestion
			{
				// private member variables								
				private ListBox m_listBox = new ListBox();
				private CheckBoxList m_checkBoxList = new CheckBoxList();
				private ListControl m_listControl = null;
	      
				// Constructor
				public McmsWebQuestion(string strId, bool bRequired, string strQuestion, string strControlBase, RepeatDirection rdLayout, string[] strResponses) :
							 base(strId, "mcms", bRequired, strQuestion)
				{ 					
					if (strControlBase == "checkbox")
					{
						m_checkBoxList.RepeatDirection = rdLayout;
						m_listControl = m_checkBoxList;
					}
					else
					{						
						m_listBox.SelectionMode = ListSelectionMode.Multiple;
						m_listControl = m_listBox;
					}
	      
					// add all the possible reponses to the underlying ListControl
					foreach (string s in strResponses)
						m_listControl.Items.Add(new ListItem(s));
	        
					// add the RadioListButton control to the McssWebQuestion's control collection (so it renders to the screen)
					m_listControl.ID = "lst_" + strId;	        
					this.Controls.Add(m_listControl);

	        // Add a ListControlValidator in the event that this is a required question	        
	        if (bRequired)
					{						
						ListControlValidator lcv = new ListControlValidator();						
						lcv.EnableClientScript = false;
						lcv.Text = "* Required";
						lcv.Display = ValidatorDisplay.Dynamic;
						lcv.ControlToValidate = m_listControl.ID;						
						this.Controls.Add(lcv);
					}					
					
					this.Controls.Add(new LiteralControl("</p>"));
				}
	      
				public override void SetAnswer()
				{
					m_strAnswer = "";
	        
					foreach (ListItem li in m_listControl.Items)
					{
						if (li.Selected)
							m_strAnswer += li.Value + "|";
					}
					
					m_strAnswer = m_strAnswer.Trim('|');
				}
			}
		}
  }
}