using System.Web.UI;
using System.Web.UI.WebControls;

namespace sstchur
{
  namespace web
  {
		namespace survey
		{
			public class McssWebQuestion : WebQuestion
			{
				// private member variables
				private RadioButtonList m_radioButtonList = new RadioButtonList();
				private DropDownList m_dropDownList = new DropDownList();	
				private ListControl m_listControl = null;			
	      
				// Constructor      
				public McssWebQuestion(string strId, bool bRequired, string strQuestion, string strControlBase, RepeatDirection rdLayout, string[] strResponses) :
							base(strId, "mcss", bRequired, strQuestion)
				{					
					if (strControlBase == "dropdown")
					{
						m_listControl = m_dropDownList;						
					}
					else
					{
						m_radioButtonList.RepeatDirection = rdLayout;
						m_listControl = m_radioButtonList;
					}
					
					// add all the possible responses to the underlying ListControl
					foreach (string s in strResponses)
						m_listControl.Items.Add(new ListItem(s));
					
					m_listControl.ID = "lst_" + strId;
					if (bRequired)
					{						
						ListControlValidator lcv = new ListControlValidator();
						lcv.EnableClientScript = false;
						lcv.Text = "* Required";
						lcv.Display = ValidatorDisplay.Dynamic;
						lcv.ControlToValidate = m_listControl.ID;						
						this.Controls.Add(lcv);						
					}
					
					this.Controls.Add(m_listControl);
					this.Controls.Add(new LiteralControl("</p>"));
				}	      
	      
				public override void SetAnswer()
				{
					this.m_strAnswer = m_listControl.SelectedValue;
				}
			}
		}
  }
}