using System.Web.UI;
using System.Web.UI.WebControls;

namespace sstchur
{
  namespace web
  {
		namespace survey
		{
			[ System.ComponentModel.ToolboxItem(false) ]
			public class WebQuestion : WebControl
			{
				// private member variables
				private string m_strId;
				private string m_strType;
				private bool m_bRequired;				
				protected string m_strAnswer;
	      
				// public member properties
				public string Id
				{ get { return m_strId; } }
	      
				public string Answer
				{ get { return m_strAnswer; } }
	      
				public bool IsRequired
				{ get { return m_bRequired; } }
	      
	      
				// public (empty) Constructor
				public WebQuestion()
				{
				}      
	      
				// protected Constructor
				protected WebQuestion(string strId, string strType, bool bRequired, string strQuestion)
				{
					// initialize privates
					m_strId = strId;
					m_strType = strType;
					m_bRequired = bRequired;        
	        
					// Render the label that displays the actual question
					// When the WebQuestion finished rendering, I want something like:
					// <p>How are you?<br>
					// <input type = "text" size = 20></p>
	        
					this.Controls.Add(new LiteralControl("<p>"));
					Label lblQuestion = new Label();
					lblQuestion.Text = strQuestion;
					this.Controls.Add(lblQuestion);
					this.Controls.Add(new LiteralControl("<br>"));        
				}
	      
				public virtual void SetAnswer()
				{
					/* Override Me! */
				}            
			}
		}
  }
}